#include <amxmodx>
#include <amxmisc>
#include <cstrike>
#include <hamsandwich>
#include <dhudmessage>
#include <fun>
#include <engine>

new const PREFIX[] = "[Вампир]"

#define ONE_LEVEL_COST	get_pcvar_num(onelevelcost)
#define TWO_LEVEL_COST	get_pcvar_num(twolevelcost)
#define THREE_LEVEL_COST	get_pcvar_num(threelevelcost)

new onelevelcost
new twolevelcost
new threelevelcost

new skokhp_onelevel
new skokhp_twolevel
new skokhp_threelevel

new haslevel[33]

new onelevel[33]
new twolevel[33]
new threelevel[33]

new keys = MENU_KEY_1|MENU_KEY_2|MENU_KEY_3|MENU_KEY_4|MENU_KEY_5|MENU_KEY_6|MENU_KEY_7|MENU_KEY_8|MENU_KEY_9|MENU_KEY_0

public plugin_init()
{
	register_plugin("vampir_shop", "0.1", "BlackSmoke")
        register_menu("Menu 1", keys, "menus1") //
	register_concmd("vm_shop", "vampir_shop")

	register_concmd("give_money", "moneymoney")

	RegisterHam(Ham_TakeDamage, "player", "player_dmg")

	onelevelcost = register_cvar("vampir_shop_onelevelcost", "")
	twolevelcost = register_cvar("vampir_shop_twolevelcost", "")
	threelevelcost = register_cvar("vampir_shop_threelevelcost", "")

        register_event("HLTV", "EventRoundStart", "a", "1=0", "2=0")

	skokhp_onelevel = register_cvar("vampir_shop_skokhp_onelevel", "")
	skokhp_twolevel = register_cvar("vampir_shop_skokhp_twolevel", "")
	skokhp_threelevel = register_cvar("vampir_shop_skokhp_threelevel", "")
}

public plugin_cfg()
{
        new configsdir[128]
        get_localinfo("amxx_configsdir", configsdir, 127)
        return server_cmd("exec %s/vm_shop.cfg", configsdir)
}

public moneymoney(id)
{
cs_set_user_money(id, 100000)
}

public EventRoundStart()
{
for(new id = 1; id <= get_maxplayers(); id++)
{
if(is_user_connected(id))
haslevel[id] = 0
onelevel[id] = false
twolevel[id] = false
threelevel[id] = false
}
}

public player_dmg(victim, ent, attacker, Float:damage, bits)
{
        if(!is_user_connected(victim) || !is_user_connected(attacker) || victim == attacker)
        return HAM_IGNORED
 
	if(onelevel[attacker] && damage >= 10.0)
	{
        set_user_health(attacker, get_user_health(attacker) + get_pcvar_num(skokhp_onelevel))
	cleardhud(attacker)
	set_dhudmessage( 0, 255, 0, -1.0, -0.35, 1, 3.0, 3.0, 0.1, 1.5 )
        show_dhudmessage(attacker, "Твоё хп: %d", get_user_health(attacker))
	}
	else if(twolevel[attacker] && damage >= 10.0)
	{
        set_user_health(attacker, get_user_health(attacker) + get_pcvar_num(skokhp_twolevel))
	cleardhud(attacker)
	set_dhudmessage( 0, 255, 0, -1.0, -0.35, 1, 3.0, 3.0, 0.1, 1.5 )
        show_dhudmessage(attacker, "Твоё хп: %d", get_user_health(attacker))
	}
	else if(threelevel[attacker] && damage >= 10.0)
	{
        set_user_health(attacker, get_user_health(attacker) + get_pcvar_num(skokhp_threelevel))
	cleardhud(attacker)
	set_dhudmessage( 0, 255, 0, -1.0, -0.35, 1, 3.0, 3.0, 0.1, 1.5 )
        show_dhudmessage(attacker, "Твоё хп: %d", get_user_health(attacker))
	}
	return HAM_IGNORED
}

public cleardhud(pId)
{
ClearDHUDMessages(pId);
}

stock ClearDHUDMessages(pId, iClear = 8)
{
for (new iDHUD = 0; iDHUD < iClear; iDHUD++)
show_dhudmessage(pId, "");
}

public vampir_shop(id)
{
	new money = cs_get_user_money(id)
        static menu[650], iLen
        iLen = 0
        iLen = formatex(menu[iLen], charsmax(menu) - iLen, "\yВампир Магазин^n\yДеньги: \r%d $^n^n", money);
	if(!(is_user_alive(id)) || haslevel[id] > 0 || money < ONE_LEVEL_COST)
	{
        iLen += formatex(menu[iLen], charsmax(menu) - iLen, "\r1. \dПервый уровень \d(+10хп за любой урон) - \r%d$^n", ONE_LEVEL_COST);
	keys &= ~MENU_KEY_1
	}
	else
	{
        iLen += formatex(menu[iLen], charsmax(menu) - iLen, "\r1. \wПервый уровень \y(+10хп за любой урон) - \r%d$^n", ONE_LEVEL_COST);
	keys |= MENU_KEY_1
	}
	if(!(is_user_alive(id)) || haslevel[id] > 0 || money < TWO_LEVEL_COST)
	{
        iLen += formatex(menu[iLen], charsmax(menu) - iLen, "\r2. \dВторой уровень \d(+30хп за любой урон) - \r%d$^n", TWO_LEVEL_COST);
	keys &= ~MENU_KEY_2
	}
	else
	{
        iLen += formatex(menu[iLen], charsmax(menu) - iLen, "\r2. \wВторой уровень \y(+30хп за любой урон) - \r%d$^n", TWO_LEVEL_COST);
	keys |= MENU_KEY_2
	}
	if(!(is_user_alive(id)) || haslevel[id] > 0 || money < THREE_LEVEL_COST)
	{
        iLen += formatex(menu[iLen], charsmax(menu) - iLen, "\r3. \dТретий уровень \d(+50хп за любой урон) - \r%d$^n^n", THREE_LEVEL_COST);
	keys &= ~MENU_KEY_3
	}
	else
	{
        iLen += formatex(menu[iLen], charsmax(menu) - iLen, "\r3. \wТретий уровень \y(+50хп за любой урон) - \r%d$^n^n", THREE_LEVEL_COST);
	keys |= MENU_KEY_3
	}
	{
        iLen += formatex(menu[iLen], charsmax(menu) - iLen, "\r0. \wВыход");
	keys |= MENU_KEY_0
	}

        show_menu(id, keys, menu, -1, "Menu 1");
        return PLUGIN_HANDLED
}

public menus1(id, key)
{
	new name[32]
	get_user_name(id, name, 31)

        switch(key)
        {

	case 0:
	{
	cs_set_user_money(id, cs_get_user_money(id) - ONE_LEVEL_COST)
	onelevel[id] = true
	twolevel[id] = false
	threelevel[id] = false
	haslevel[id]++
	Color_Print(0, "!g%s !yИгрок !team%s !yКупил первый уровень вампира", PREFIX, name)
	}

	case 1:
	{
	cs_set_user_money(id, cs_get_user_money(id) - TWO_LEVEL_COST)
	onelevel[id] = false
	twolevel[id] = true
	threelevel[id] = false
	haslevel[id]++
	Color_Print(0, "!g%s !yИгрок !team%s !yКупил второй уровень вампира", PREFIX, name)
	}

	case 2:
	{
	cs_set_user_money(id, cs_get_user_money(id) - THREE_LEVEL_COST)
	onelevel[id] = false
	twolevel[id] = false
	threelevel[id] = true
	haslevel[id]++
	Color_Print(0, "!g%s !yИгрок !team%s !yКупил третий уровень вампира", PREFIX, name)
	}

	}
}

stock Color_Print(const id, const input[], any:...)
{
	new count = 1, players[32]
	static msg[191]
	vformat(msg, 190, input, 3)
	
	replace_all(msg, 190, "!g", "^4") // Green Color
	replace_all(msg, 190, "!y", "^1") // Default Color
	replace_all(msg, 190, "!team", "^3") // Team Color
	
	if (id) players[0] = id; else get_players(players, count, "ch")
	{
		for (new i = 0; i < count; i++)
		{
			if (is_user_connected(players[i]))
			{
				message_begin(MSG_ONE_UNRELIABLE, get_user_msgid("SayText"), _, players[i])
				write_byte(players[i]);
				write_string(msg);
				message_end();
			}
		}
	}
}